/*
 *           Horloge DCF77 
 * Parlante ou sonnerie toutes les heures 
 *   
 * Patientez au moins 2 minutes à la mise en route.
 * 
 * Informations complémentaires
 * sur mon site : http://f5mna.free.fr
 * 
 * Version 1.2 Aout 2017 
 *         1.3 Janvier 2018
 */

#include "DCF77.h"
#include "TimeLib.h"
/////////////////Sonneries MP3//////////////////////
#include <SoftwareSerial.h>
#include <DFPlayer_Mini_Mp3.h>
SoftwareSerial mySerial(10, 11); // RX, TX
//////////////////////////////////////////////////

#define DCF_PIN 2	        // Connexion pin data au module DCF 77
#define DCF_INTERRUPT 0		// Interruption correspondant à pin 2
#define SCloches  12      // Choix sonnerie/parlante
#define Parlez  3        // Parle   

int mois,valCloche,valParle; 

time_t time;
DCF77 DCF = DCF77(DCF_PIN,DCF_INTERRUPT);

//LCD
#include <LiquidCrystal.h>
// LCD RS pin vers pin D8
// LCD Enable vers pin D9
// LCD DB4 pin vers pin D4
// LCD DB5 pin vers pin D5
// LCD DB6 pin vers pin D6
// LCD DB7 pin vers pin D7
// LCD R/W pin vers ground
LiquidCrystal lcd(8, 9, 4, 5, 6, 7);

int seconde;

void setup() {
   Serial.begin(9600); 
   pinMode(SCloches, INPUT);    // pin 12 input
   pinMode(Parlez, INPUT);      // pin 3 input
  ///// Sonneries///////////
   mySerial.begin(9600);
   delay(400);
   mp3_set_serial (mySerial); 
   delay(400);
   mp3_set_volume (25);         //  Volume de 0 à 30 
   delay(400);
 /////////////////////////// 
 
 
 //Presentation
 lcd.begin(16, 2); 
 lcd.setCursor(0, 0);
 lcd.print (" HORLOGE  DCF77 ");
 lcd.setCursor(0, 1);
 lcd.print ("   F5MNA V 1.2  ");
 delay(3000);
 lcd.setCursor(0, 0);
 lcd.print ("                 ");
 lcd.setCursor(0, 1);
 lcd.print ("                 "); 
 DCF.Start();
 delay (200);
 mp3_play (1000);
 delay (1000); 
 Serial.println("Patientez au moins 2 minutes avant de recevoir les premieres donnees.");
}

void loop() {
  
  valParle = digitalRead(Parlez);     // Poussoir "Parle".            pin 3   
  valCloche = digitalRead(SCloches);  // Selection Parlante/sonnerie. pin 13
     
  time_t DCFtime = DCF.getTime();  
  if (DCFtime!=0)
  {
    Serial.println("Heure mise à jour");
    setTime(DCFtime);
  }	
     
  if (year() == 1970) {   
  lcd.setCursor( 4, 0 );
  lcd.print ("Patientez");
  lcd.setCursor( 5, 1 );
  for (int x = 0; x < 9; x++)
  {lcd.setCursor( 4 + x, 1 );
  lcd.print ("-");
  lcd.setCursor( 4 + x, 1 );
  delay (500);}
  lcd.setCursor( 3, 1 );
  lcd.print ("           "); 
  }
  else{
  if ((valCloche == 0) &&  (minute() == 59) && (second()== 59)) Cloche();
  if ((valParle == 0)&& (valCloche == 1)) Parle();
  if  (seconde!= second())
  (digitalClockDisplay());}   
}

void digitalClockDisplay(){
  Serial.print(hour());
  Serial.print(" ");
  Serial.print(minute());
  Serial.print(" ");
  Serial.print(second());
  Serial.println();
  Serial.print(day());
  Serial.print(" ");
  Serial.print(month());
  Serial.print(" ");
  Serial.print(year());
  Serial.println(); 
  Serial.println();
  lcd.setCursor( 4, 0 );
  if ((hour()) < 10) {lcd.print ("0");} 
  lcd.print (hour());
  lcd.print( ":");
  if (minute() < 10) { lcd.print ("0");}
  lcd.print (minute());
  lcd.print( ":" );
  if (second()< 10) { lcd.print ("0");}
  lcd.print( second() );
  lcd.print("   ");
  
  if (mois != month()) {  // Changement de mois
  lcd.setCursor( 0, 1 );
  lcd.print  ("                ");}
  
  switch (month()){
    case 1:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
         lcd.print  ("Janvier");
     break;
    case 2:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
         lcd.print  ("fevrier");
    break;
    case 3:
         lcd.setCursor( 2, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("mars");
    break;
     case 4:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("avril");
    break;
     case 5:
         lcd.setCursor(3, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("mai");
    break;
     case 6:        
        lcd.setCursor( 2, 1 );
        if (day() < 10) { lcd.print ("0");}
        lcd.print(day());
        lcd.print( " ");
        lcd.print ("juin");
    break;
    case 7:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("Juillet");
    break;
     case 8:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("aout");
    break;
     case 9:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("septem.");
    break;
     case 10:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
        lcd.print ("octobre");
    break;
     case 11:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
         lcd.print ("novemb.");
    break;
     case 12:
         lcd.setCursor( 1, 1 );
         if (day() < 10) { lcd.print ("0");}
         lcd.print(day());
         lcd.print( " ");
         lcd.print ("decemb.");
    break;
    }
         lcd.print( " " );
         lcd.print(year());
         mois = month();  
        seconde = second();          
   }  

void Parle()
{ 
   mp3_play (3300); //il est
   delay (650);

  switch (hour()) {

    case 0:
      mp3_play (2200); //zero
      delay (850);
      break;

    case 1:
      mp3_play (2201); //1
      delay (750);
      break;

    case 2:
      mp3_play (2202); //2
      delay (750);
      break;

    case 3:
      mp3_play (2203); //3
      delay (750);
      break;

    case 4:
      mp3_play (2204); //4
      delay (750);
      break;

    case 5:
      mp3_play (2205); //5
      delay (750);
      break;

    case 6:
      mp3_play (2206); //6
      delay (750);
      break;

    case 7:
      mp3_play (2207); //7
      delay (750);
      break;

    case 8:
      mp3_play (2208); //8
      delay (750);
      break;

    case 9:
      mp3_play (2209); //9
      delay (750);
      break;

    case 10:
      mp3_play (2210); //10
      delay (750);
      break;

    case 11:
      mp3_play (2211); //11
      delay (750);
      break;

    case 12:
      mp3_play (2212); //12
      delay (750);
      break;

    case 13:
      mp3_play (2213); //13
      delay (750);
      break;

    case 14:
      mp3_play (2214); //14
      delay (900);
      break;

    case 15:
      mp3_play (2215); //15
      delay (750);
      break;

    case 16:
      mp3_play (2216); // 16
      delay (750);
      break;

    case 17:
      mp3_play (2217); //10
      delay (850);
      break;

    case 18:
      mp3_play (2218); //10
      delay (850);
      break;

    case 19:
      mp3_play (2219); //10
      delay (850);
      break;

    case 20:
      mp3_play (2220); //20
      delay (750);
      break;

    case 21:
      mp3_play (2221); //20
      delay (950);
      break;

    case 22:
      mp3_play (2222); //20
      delay (1000);
      break;

    case 23:
      mp3_play (2223); //20
      delay (1000);
      break;
  }

  // mp3_play (3301); //  et
  delay (250);
  //////////////////////////////////////////////
  //////////////////////////////////////////////
  switch (minute()) {

    case 0:
      mp3_play (1100); //zero
      delay (250);
      break;

    case 1:
      mp3_play (1101); //1
      delay (250);
      break;

    case 2:
      mp3_play (1102); //2
      delay (250);
      break;

    case 3:
      mp3_play (1103); //3
      delay (250);
      break;

    case 4:
      mp3_play (1104); //4
      delay (250);
      break;

    case 5:
      mp3_play (1105); //5
      delay (250);
      break;

    case 6:
      mp3_play (1106); //6
      delay (250);
      break;

    case 7:
      mp3_play (1107); //7
      delay (250);
      break;

    case 8:
      mp3_play (1108); //8
      delay (250);
      break;

    case 9:
      mp3_play (1109); //9
      delay (250);
      break;

    case 10:
      mp3_play (1110); //10
      delay (250);
      break;

    case 11:
      mp3_play (1111); //11
      delay (250);
      break;

    case 12:
      mp3_play (1112); //12
      delay (250);
      break;

    case 13:
      mp3_play (1113); //13
      delay (250);
      break;

    case 14:
      mp3_play (1114); //14
      delay (250);
      break;

    case 15:
      mp3_play (1115); //15
      delay (250);
      break;

    case 16:
      mp3_play (1116); // 16
      delay (250);
      break;

    case 17:
      mp3_play (1117); //10
      delay (250);
      break;

    case 18:
      mp3_play (1118); //10
      delay (250);
      break;

    case 19:
      mp3_play (1119); //10
      delay (250);
      break;

    case 20:
      mp3_play (1120); //20
      delay (250);
      break;

    case 21:
      mp3_play (1121); //21
      delay (250);
      break;

    case 22:
      mp3_play (1122); //22
      delay (250);
      break;

    case 23:
      mp3_play (1123); //23
      delay (250);
      break;

    case 24:
      mp3_play (1124); //24
      delay (250);
      break;

    case 25:
      mp3_play (1125); //25
      delay (250);
      break;

    case 26:
      mp3_play (1126); //26
      delay (250);
      break;

    case 27:
      mp3_play (1127); //27
      delay (250);
      break;

    case 28:
      mp3_play (1128); //28
      delay (250);
      break;

    case 29:
      mp3_play (1129); //29
      delay (250);
      break;

    case 30:
      mp3_play (1130); //30
      delay (250);
      break;

    case 31:
      mp3_play (1131); //31
      delay (300);
      break;

    case 32:
      mp3_play (1132); //32
      delay (350);
      break;

    case 33:
      mp3_play (1133); //33
      delay (350);
      break;

    case 34:
      mp3_play (1134); //34
      delay (350);
      break;

    case 35:
      mp3_play (1135); //35
      delay (350);
      break;

    case 36:
      mp3_play (1136); //36
      delay (250);
      break;

    case 37:
      mp3_play (1137); //37
      delay (350);
      break;

    case 38:
      mp3_play (1138); //38
      delay (350);
      break;

    case 39:
      mp3_play (1139); //39
      delay (350);

      break;

    case 40:
      mp3_play (1140); //40
      delay (750);
      break;

    case 41:
      mp3_play (1141); //41
      delay (750);
      break;

    case 42:
      mp3_play (1142); //42
      delay (750);
      break;

    case 43:
      mp3_play (1143); //43
      delay (750);

      break;

    case 44:
      mp3_play (1144); //44
      delay (750);
      break;

    case 45:
      mp3_play (1145); //45
      delay (750);
      break;

    case 46:
      mp3_play (1146); //46
      delay (750);
      break;

    case 47:
      mp3_play (1147); //47
      delay (750);
      break;

    case 48:
      mp3_play (1148); //48
      delay (750);
      break;

    case 49:
      mp3_play (1149); //49
      delay (750);
      break;

    case 50:
      mp3_play (1150); //50
      delay (600);
      break;

    case 51:
      mp3_play (1151); //51
      delay (600);
      break;

    case 52:
      mp3_play (1152); //52
      delay (600);
      break;

    case 53:
      mp3_play (1153); //53
      delay (600);

      break;

    case 54:
      mp3_play (1154); //54
      delay (600);
      break;

    case 55:
      mp3_play (1155); //55
      delay (600);
      break;

    case 56:
      mp3_play (1156); //56
      delay (600);
      break;

    case 57:
      mp3_play (1157); //57
      delay (600);
      break;

    case 58:
      mp3_play (1158); //58
      delay (600);
      break;

    case 59:
      mp3_play (1159); //59
      delay (600);
      break;
  }
}

      
void Cloche()
{  
  Serial.println ("Cloche"); 
  switch (hour()){  
      case 0:
      mp3_play  (4001); //
      delay (1000);
      break;
      case 1:
      mp3_play  (4002); //
      delay (1000);
      break;
      case 2:
      mp3_play  (4003); //
      delay (1000);
      break;
      case 3:
      mp3_play  (4004); //
      delay (1000);
      break;
      case 4:
      mp3_play  (4005); //
      delay (1000);
      break;
      case 5:
      mp3_play  (4006); //
      delay (1000);
      break;
      case 6:
      mp3_play  (4007); //
      delay (1000);
      break;
      case 7:
      mp3_play  (4008); //
      delay (1000);
      break;
      case 8:
      mp3_play  (4009); //
      delay (1000);
      break;
      case 9:
      mp3_play  (4010); //
      delay (1000);
      break;
      case 10:
      mp3_play  (4011); //
      delay (1000);
      break;
      case 11:      
      mp3_play  (4012); //
      delay (1000);
      break;
      case 12:
      mp3_play  (4001); //
      delay (1000);
      break;
      case 13:
      mp3_play  (4002); //
      delay (1000);
      break;
      case 14:
      mp3_play  (4003); //
      delay (1000);
      break;
      case 15:
      mp3_play  (4004); //
      delay (1000);
      break;
      case 16:
      mp3_play  (4005); //
      delay (1000);
      break;
      case 17:
      mp3_play  (4006); //
      delay (1000);
      break;
      case 18:
      mp3_play  (4007); //
      delay (1000);
      break;
      case 19:
      mp3_play  (4008); //
      delay (1000);
      break;
      case 20:
      mp3_play  (4009); //
      delay (1000);
      break;
      case 21:
      mp3_play  (4010); //
      delay (1000);
      break;
      case 22:
      mp3_play  (4011); //
      delay (1000);
      break;
      case 23:
      mp3_play  (4012); //
      delay (1000);
      break;
  }  
  }
      
